'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var core = require('@octokit/core');
var authAction = require('@octokit/auth-action');
var pluginPaginateRest = require('@octokit/plugin-paginate-rest');
var pluginRestEndpointMethods = require('@octokit/plugin-rest-endpoint-methods');
var ProxyAgent = _interopDefault(require('proxy-agent'));

const VERSION = "4.0.4";

const DEFAULTS = {
  authStrategy: authAction.createActionAuth,
  baseUrl: getApiBaseUrl(),
  userAgent: `octokit-action.js/${VERSION}`
};
const Octokit = core.Octokit.plugin(pluginPaginateRest.paginateRest, pluginRestEndpointMethods.legacyRestEndpointMethods).defaults(function buildDefaults(options) {
  return { ...DEFAULTS,
    ...options,
    request: {
      agent: new ProxyAgent(),
      ...options.request
    }
  };
});

function getApiBaseUrl() {
  /* istanbul ignore next */
  return process.env["GITHUB_API_URL"] || "https://api.github.com";
}

exports.Octokit = Octokit;
//# sourceMappingURL=index.js.map
