"use strict";
/*
 * Copyright (c) 2018, salesforce.com, inc.
 * All rights reserved.
 * Licensed under the BSD 3-Clause license.
 * For full license text, see LICENSE.txt file in the repo root or https://opensource.org/licenses/BSD-3-Clause
 */
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@oclif/core");
const telemetry_1 = require("@salesforce/telemetry");
const telemetry_2 = require("../telemetry");
class TelemetryGet extends core_1.Command {
    async run() {
        var _a;
        const enabled = await telemetry_1.default.determineSfdxTelemetryEnabled();
        this.log(`Telemetry is ${enabled ? 'enabled' : 'disabled'}.`);
        this.log(`Telemetry tmp directory is ${telemetry_2.default.tmpDir}.`);
        this.log(`Telemetry cache directory is ${this.config.cacheDir}.`);
        this.log();
        this.log(`Salesforce CLI ID is ${(_a = global.cliTelemetry) === null || _a === void 0 ? void 0 : _a.getCLIId()}.`);
    }
}
exports.default = TelemetryGet;
TelemetryGet.hidden = true;
//# sourceMappingURL=telemetry.js.map